# This software is copyright PSI Net Consulting Services 
# released under the Zope Public License http://www.zope.org/Resources/ZPL
# Any programming questions should be directed to 
# doug.thompson@psinetcs.com (work email) or
# zclips@raystream.com (personal email)

# Disclaimer
# 
#   THIS SOFTWARE IS PROVIDED BY PSI Net Consulting Services ``AS IS'' AND ANY
#   EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#   PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL PSINet Consulting Services OR ITS
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# 

import string
import sys
import os
import socket
import traceback

def tracebackAsString(limit):
	type, value, tb = sys.exc_info()
	aList = traceback.format_exception(type, value, tb, limit)
	formattedString = ""
	for s in aList:
		formattedString = formattedString + s + "\n"
	return formattedString

def getClipsQuestion():
	try:
		clientsock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		
		question = ""
		clientsock.connect("localhost", 8578)
		clientsock.send("getClipsQuestion")
		question = clientsock.recv(1024)
		clientsock.close()
	except Exception, data:
		s = tracebackAsString(25)
		try:
			clientsock.close()
		except:
			pass
		return s
	
	return question
	
def sendZopeAnswer(REQUEST, RESPONSE):
	try:
		answer = "yes"
		try:
			test = REQUEST["yesButton"]
		except:	
			answer = "no"
		
		clientsock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		
		clientsock.connect("localhost", 8578)
		clientsock.send("sendZopeAnswer:" + answer)
		clientsock.close()
		
		RESPONSE.redirect("http://" + REQUEST.SERVER_NAME + ":8080//Tools/clipsWork/askQuestion")

	except Exception, data:
		s = tracebackAsString(25)
		try:
			clientsock.close()
		except:
			pass
		return s
	
	return "Answer sent."

def resetClips():	
	try:
		clientsock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		
		clientsock.connect("localhost", 8578)
		clientsock.send("Reset")
		clientsock.close()

	except Exception, data:
		s = tracebackAsString(25)
		try:
			clientsock.close()
		except:
			pass
		return s
		
	return "Expert system is now ready."
