# This software is copyright PSI Net Consulting Services 
# released under the Zope Public License http://www.zope.org/Resources/ZPL
# Any programming questions should be directed to 
# doug.thompson@psinetcs.com (work email) or
# zclips@raystream.com (personal email)

# Disclaimer
# 
#   THIS SOFTWARE IS PROVIDED BY PSI Net Consulting Services ``AS IS'' AND ANY
#   EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#   PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL PSINet Consulting Services OR ITS
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# 

#imports

import win32ui  
import dde      
import string
import sys
import os
import socket
import select
import time
import msvcrt

#module level variables

conversation = None
server = None

HOST = ''			#this means local
PORT = 8578			#arbitrary, high number

#functions

def getClipsQuestion():
	conversation.Exec("PrepareCLIPSQuestion") 
	q = conversation.Request("GetCLIPSQuestion") 
	return q
	
def sendZopeAnswer(answer):
	if answer == "yes":
		conversation.Exec("Answer:yes")
	else:	
		conversation.Exec("Answer:no")
	return
	
def resetClips():
	conversation.Exec("Reset")
	return
	
def disconnect():
	conversation.Exec("Disconnnect")
	return
	
def initializeDDE():
	global conversation, server
	server = dde.CreateServer()
	server.Create("TestClient")
	conversation = dde.CreateConversation(server)
	conversation.ConnectTo("DDETEST", "DDETEST")
	return
	
def serve():
	ddeConnectionEstablished = 0
	for i in range(0, 10):
		try:
			initializeDDE()
			ddeConnectionEstablished = 1
			print "DDE connection successfully established with wxClips."
			break
		except:
			print "Error establishing DDE connection with wxClips. Will retry in 10 seconds."
			time.sleep(10)
	if not ddeConnectionEstablished:
		print "Cannot establish DDE connection with wxClips. Terminating."
		return
	
	serversock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	serversock.bind(HOST, PORT)
	serversock.listen(5)
	
	try:
		while 1:
			time.sleep(0.05)
			
			#check for user keypress--wants to shutdown server
			if msvcrt.kbhit():
				break
				
			#poll the socket for activity
			input, output, exc = select.select([serversock], [], [], 0)

			for sock in input:
				handlersock, addr = sock.accept()
				data = handlersock.recv(1024)

				if data == "getClipsQuestion":
					q = getClipsQuestion()

					handlersock.send(q)
					handlersock.close()
					
				elif data == "Reset":
					resetClips()
					handlersock.close()

				elif data[0:14] == "sendZopeAnswer":

					#expecting "sendZopeAnswer:no" or "sendZopeAnswer:yes"
					sendZopeAnswer(data[15:18])	
					handlersock.close()
				else:
					handlersock.close()

	except Exception, ex:
		print "Exception in ddeclient: " + `ex`
		try:
			serversock.close()
		except:
			pass
		try:
			handlersock.close()
		except:
			pass
		try:
			disconnect()
		except:
			pass
	
	try:
		serversock.close()
	except:
		pass
	try:	
		disconnect()
	except:
		pass
	return
	
if __name__ == "__main__":
	serve()
	